'use strict';

var _Map = require('babel-runtime/core-js/map')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.store = store;
exports.retrieve = retrieve;
exports.drop = drop;
exports.dangerouslyProcessChildrenUpdates = dangerouslyProcessChildrenUpdates;

var _ReactTitaniumChildrenOperations = require('./ReactTitaniumChildrenOperations');

var cache = new _Map();

function store(id, view) {
  cache.set(id, view);
}

function retrieve(id) {
  return cache.get(id);
}

function drop(id) {
  cache['delete'](id);
}

function dangerouslyProcessChildrenUpdates(updates, components) {
  for (var i = 0, l = updates.length; i < l; ++i) {
    updates[i].parentNode = retrieve(updates[i].parentID);
  }

  (0, _ReactTitaniumChildrenOperations.processChildrenUpdates)(updates, components);
}